unit Antialiasing_ej3;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ComCtrls, ExtDlgs, Spin;


type
  TRGBTripleArray = array[0..32767] of TRGBTriple;
  PRGBTripleArray = ^TRGBTripleArray;

  TForm1 = class(TForm)
    img1: TImage;
    btn1: TButton;
    OpenD: TOpenPictureDialog;
    sb1: TStatusBar;
    img5: TImage;
    Memo1: TMemo;
    Label2: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    Label3: TLabel;
    rgDim: TRadioGroup;
    GroupBox1: TGroupBox;
    Label4: TLabel;
    Label6: TLabel;
    seAncho: TSpinEdit;
    seAlto: TSpinEdit;
    procedure btn1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure rgDimClick(Sender: TObject);
  private
    function _NewColor3(X,Y:integer;SL1, SL2, SL3:PRGBTripleArray):TColor;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
  Math, FormImg;




// Esta cambia el alto y ancho, estirando la imagen si es necesario
procedure Redimensionar(Imagen:TBitmap; Ancho, Alto: Integer);
var
  Bitmap: TBitmap;
  //
  // Procedimiento de Antialiasing con Distancia=1
  procedure Antialiasing(bmp1, bmp2:TBitmap);
  var
    r1,g1,b1:Integer;
    Y, X, j:integer;
    SL1, SL2, SL3: PRGBTripleArray;
  begin

    // Tamao del bitmap destino
    bmp2.Height := bmp1.Height;
    bmp2.Width := bmp1.Width;
    // SCANLINE
    SL1 := bmp1.ScanLine[0];
    SL2 := bmp1.ScanLine[1];
    SL3 := bmp1.ScanLine[2];

    // reorrido para todos los pixels
    for Y := 1 to (bmp1.Height - 2) do begin
      for X := 1 to (bmp1.Width - 2) do begin
        R1 := 0;  G1 := 0; B1 := 0;
        // los 9 pixels a tener en cuenta
        for j := -1 to 1 do begin
          // FIla anterior
          R1 := R1 + SL1[X+j].rgbtRed    + SL2[X+j].rgbtRed    + SL3[X+j].rgbtRed;
          G1 := G1 + SL1[X+j].rgbtGreen  + SL2[X+j].rgbtGreen  + SL3[X+j].rgbtGreen;
          B1 := B1 + SL1[X+j].rgbtBlue   + SL2[X+j].rgbtBlue   + SL3[X+j].rgbtBlue;
        end;
        // Nuevo color
        R1:=Round(R1 div 9);
        G1:=Round(G1 div 9);
        B1:=Round(B1 div 9);
        // Asignar el nuevo
        bmp2.Canvas.Pixels[X, Y] := RGB(R1,G1,B1);
      end;
      // Siguientes...
      SL1 := SL2;
      SL2 := SL3;
      SL3 := bmp1.ScanLine[Y+1];
    end;
  end;
  //  
begin

  Bitmap:= TBitmap.Create;

  // Aplicamos antialiasing
  Antialiasing(Imagen, Bitmap);
  Imagen.Assign(Bitmap);

  // reducir
  try
    Bitmap.Width:= Ancho;
    Bitmap.Height:= Alto;
    Bitmap.Canvas.StretchDraw(Bitmap.Canvas.ClipRect, Imagen);
    Imagen.Assign(Bitmap);
  finally
    Bitmap.Free;
  end;
end;



function TForm1._NewColor3(X,Y:integer;SL1, SL2, SL3: PRGBTripleArray):TColor;
var
  r1,g1,b1:Integer;
  r2, g2,b2:Integer;
  r3, g3,b3:Integer;
  r4, g4,b4:Integer;
  r5, g5,b5:Integer;
  r6, g6,b6:Integer;
  r7, g7,b7:Integer;
  r8, g8,b8:Integer;
  r9, g9,b9:Integer;
  i:Integer;
begin


  // nuevo color
  Result := RGB(R1,G1,B1);

end;


procedure TForm1.btn1Click(Sender: TObject);
var
  SR1, SR2, SR3, SR0: PRGBTripleArray;
  X,Y:Integer;
  newColor:integer;
  C1, C5:TCanvas;
  fName:string;
begin

  // redimensionar + Antialiasing
  img1.Picture.LoadFromFile(OpenD.FileName);
  Redimensionar(img1.Picture.Bitmap, seAncho.Value, seAlto.Value);

  // en esta cargo el original
  img5.Picture.LoadFromFile(OpenD.FileName);


  // IAMGEN CON ANTIALIASING
  FImg := TFImg.Create(Self);
  FImg.Image1.Picture.Bitmap.Assign(img1.Picture.Bitmap);
  FImg.Caption := 'imagen reducida con Antialiasing';
  FImg.Show;
  FImg.Left := (Screen.Width DIV 4);
  FImg.Top := (Screen.Width DIV 4);

  // IMAGEN NORMAL
  FImg := TFImg.Create(Self);
  FImg.Image1.Picture.Bitmap.Assign(img5.Picture.Bitmap);
  FImg.AutoSize := False;
  FImg.Image1.AutoSize := False;
  FImg.Image1.Stretch := True;
  FImg.Image1.Width := seAncho.Value;
  FImg.Image1.Height := seAlto.Value;
  FImg.Width := seAncho.Value;
  FImg.Height := seAlto.Value;
  FImg.AutoSize := True;
  FImg.Caption := 'Imagen original';
  FImg.Show;

  FImg.Left := (Screen.Width DIV 6);
  FImg.Top := (Screen.Width DIV 6);

  Exit;

end;


procedure TForm1.Button1Click(Sender: TObject);
begin
  OpenD.InitialDir := ExtractFilePath(Application.ExeName);
  if OpenD.Execute then begin
    img1.Picture.Bitmap.LoadFromFile(OpenD.FileName);
    btn1.Enabled := true;

    if not Assigned(img5.Picture.Bitmap) then begin
      img5.Picture.Bitmap := TBitmap.Create();
    end;

    seAlto.Value := img1.Picture.Bitmap.Height;
    seAncho.Value := img1.Picture.Bitmap.Width;

    rgDim.Enabled := True;

  end;
end;

procedure TForm1.rgDimClick(Sender: TObject);
begin

  GroupBox1.Enabled := True;
  img1.Picture.Bitmap.LoadFromFile(OpenD.FileName);

  if (rgDim.ItemIndex = 0) then begin
    seAlto.Value := img1.Picture.Bitmap.Height;
    seAncho.Value := img1.Picture.Bitmap.Width;
  end
  else if (rgDim.ItemIndex = 1) then begin
    seAlto.Value := (img1.Picture.Bitmap.Height div 2);
    seAncho.Value := (img1.Picture.Bitmap.Width div 2);
  end
  else if (rgDim.ItemIndex = 2) then begin
    seAlto.Value := (img1.Picture.Bitmap.Height div 4);
    seAncho.Value := (img1.Picture.Bitmap.Width div 4);
  end
  else begin
    seAlto.SetFocus;
  end;

  GroupBox1.Enabled := (rgDim.ItemIndex = 3);
end;

end.


